- Public/Stable/Replaceable
  - verify_multijdk_test
- Public/Stable/Not Replaceable
  - add_footer_table
  - add_header_line
  - add_test_table
  - add_vote_table
  - add_vote_table_v2
  - big_console_header
  - clock_display
  - echo_and_redirect
  - git_checkout_force
  - git_clean
  - offset_clock
  - setup_defaults
  - start_clock
  - stop_clock
  - write_comment
  - yetus_usage
- Public/Evolving/Not Replaceable
  - archive
  - buildtool_cwd
  - calcdiffs
  - clear_personality_queue
  - column_calcdiffs
  - compile
  - compile_cycle
  - compile_jvm
  - compile_nonjvm
  - dequeue_personality_module
  - distclean
  - error_calcdiffs
  - generic_calcdiff_status
  - generic_logfilter
  - generic_post_handler
  - generic_postlog_compare
  - generic_pre_handler
  - initialize
  - module_post_handler
  - module_postlog_compare
  - module_pre_handler
  - module_status
  - modules_backup
  - modules_messages
  - modules_reset
  - modules_restore
  - modules_workers
  - patchfiletests
  - personality_enqueue_module
  - root_postlog_compare
- Private/Stable/Replaceable
  - prepopulate_footer
  - report_jvm_version
- Private/Evolving/Replaceable
  - start_coprocessors
  - stop_coprocessors
  - verify_patchdir_still_exists

## Public/Stable/Replaceable

### `verify_multijdk_test`

- Synopsis

    verify_multijdk_test test

- Description

Verify if a given test is multijdk

- Returns

0 = yes

1 = no

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | Yes

## Public/Stable/Not Replaceable

### `add_footer_table`

- Synopsis

    add_footer_table subsystem string

- Description

Add to the footer of the display. @@BASE@@ will get replaced with the correct location for the local filesystem in dev mode or the URL for Jenkins mode.

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `add_header_line`

- Synopsis

    add_header_line string

- Description

Add to the header of the display

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `add_test_table`

- Synopsis

    add_test_table failurereason testlist

- Description

Special table just for unit test failures

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `add_vote_table`

- Synopsis

    add_vote_table

- Description

Deprecated. Use add_vote_table_v2 instead.

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `add_vote_table_v2`

- Synopsis

    add_vote_table_v2 +1/0/-1/H subsystem logfile string

- Description

Add to the output table. If the first parameter is a number that is the vote for that column and calculates the elapsed time based upon the last start_clock(). The second parameter is the reporting subsystem (or test) that is providing the vote. The second parameter is always required. The third parameter is any extra verbage that goes with that subsystem. if the vote is H, then that designates that "subsystem" should be a header in the vote table comment output. The other parameters are ignored

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `big_console_header`

- Synopsis

    big_console_header string

- Description

Large display for the user console

- Returns

large chunk of text

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `clock_display`

- Synopsis

    clock_display seconds

- Description

Convert time in seconds to m + s

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `echo_and_redirect`

- Synopsis

    echo_and_redirect filename command [..]

- Description

Print the command to be executing to the screen. Then run the command, sending stdout and stderr to the given filename This will also ensure that any directories in ${BASEDIR} have the exec bit set as a pre-exec step.

- Returns

$?

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `git_checkout_force`

- Synopsis

    git_checkout_force

- Description

Forcibly reset the tree back to it's original state

- Returns

0 on success

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `git_clean`

- Synopsis

    git_clean

- Description

git clean the repository

- Returns

0 on success

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `offset_clock`

- Synopsis

    offset_clock seconds

- Description

Add time to the local timer

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `setup_defaults`

- Synopsis

    setup_defaults

- Description

Setup the default global variables

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `start_clock`

- Synopsis

    start_clock

- Description

Activate the local timer

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `stop_clock`

- Synopsis

    stop_clock

- Description

Print the elapsed time in seconds since the start of the local timer

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `write_comment`

- Synopsis

    write_comment filename

- Description

Write the contents of a file to all of the bug systems (so content should avoid special formatting)

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `yetus_usage`

- Synopsis

    yetus_usage

- Description

Print the usage information

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

## Public/Evolving/Not Replaceable

### `archive`

- Synopsis

    archive

- Description

Save file names and directory to the patch dir

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `buildtool_cwd`

- Synopsis

    buildtool_cwd MODULE_ index

- Description

change the working directory to execute the buildtool

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `calcdiffs`

- Synopsis

    calcdiffs branchlog patchlog testtype

- Description

Wrapper to call specific version of calcdiffs if available otherwise calls error_calcdiffs

- Returns

differences

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `clear_personality_queue`

- Synopsis

    clear_personality_queue

- Description

Reset the queue for tests

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `column_calcdiffs`

- Synopsis

    column_calcdiffs branchlog patchlog

- Description

Calculate the differences between the specified files using just the column+ messages (third+ column in a colon delimated file) and output it to stdout.

- Returns

differences

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `compile`

- Synopsis

    compile branch|patch

- Description

Execute the compile phase. This will callout to _compile

- Returns

0 on success

1 on failure

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `compile_cycle`

- Synopsis

    compile_cycle branch|patch

- Description

Execute the static analysis test cycle. This will callout to _precompile, compile, _postcompile and _rebuild

- Returns

0 on success

1 on failure

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `compile_jvm`

- Synopsis

    compile_jvm branch|patch

- Description

Execute the compile phase. This will callout to _compile

- Returns

0 on success

1 on failure

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `compile_nonjvm`

- Synopsis

    compile_nonjvm branch|patch

- Description

Execute the compile phase. This will callout to _compile

- Returns

0 on success

1 on failure

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `dequeue_personality_module`

- Synopsis

    dequeue_personality_module modulenames

- Description

Remove a module

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `distclean`

- Synopsis

    distclean

- Description

Wipe the repo clean to not invalidate tests

- Returns

0 on success

1 on failure

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `error_calcdiffs`

- Synopsis

    error_calcdiffs branchlog patchlog

- Description

Calculate the differences between the specified files using just the error messages (last column in a colon delimated file) and output it to stdout.

- Returns

differences

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `generic_calcdiff_status`

- Synopsis

    generic_calcdiff_status totalbranchissues totalpatchissues newpatchissues

- Description

generate a standardized calcdiff status message

- Returns

errorstring

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `generic_logfilter`

- Synopsis

    generic_logfilter

- Description

Helper routine for plugins to ask projects, etc to count problems in a log file and output it to stdout.

- Returns

number of issues

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `generic_post_handler`

- Synopsis

    generic_post_handler

- Description

Deprecated. Use module_post_handler instead.

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `generic_postlog_compare`

- Synopsis

    generic_postlog_compare

- Description

Deprecated. Use module_postlog_compare instead.

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `generic_pre_handler`

- Synopsis

    generic_pre_handler testype multijdk

- Description

Deprecated. Use module_pre_handler instead.

- Returns

1 on failure

0 on success

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `initialize`

- Synopsis

    initialize $@

- Description

Setup to execute

- Returns

0 on success

1 on failure

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `module_post_handler`

- Synopsis

    module_post_handler origlog testtype multijdkmode run commands

- Description

Generic post-patch handler

- Returns

0 on success

1 on failure

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `module_postlog_compare`

- Synopsis

    module_postlog_compare origlog testtype multijdkmode

- Description

Module post-patch log handler

- Returns

0 on success

1 on failure

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `module_pre_handler`

- Synopsis

    module_pre_handler testype multijdk

- Description

Helper routine for plugins to do a pre-patch run

- Returns

1 on failure

0 on success

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `module_status`

- Synopsis

    module_status moduleindex -1-0|0|+1 logvalue message

- Description

Add or update a test result. Update requires at least the first two parameters. WARNING: If the message is updated, then the JDK version is also calculated to match the current JAVA_HOME.

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `modules_backup`

- Synopsis

    modules_backup

- Description

Backup the MODULE globals prior to loop processing

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `modules_messages`

- Synopsis

    modules_messages repostatus testtype summarymode

- Description

Utility to print standard module errors

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `modules_reset`

- Synopsis

    modules_reset

- Description

Reset the test results

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `modules_restore`

- Synopsis

    modules_restore

- Description

Restore the backup

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `modules_workers`

- Synopsis

    modules_workers repostatus testtype mvncmdline

- Description

run the tests for the queued modules

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `patchfiletests`

- Synopsis

    patchfiletests branch|patch

- Description

Execute the patch file test phase. Calls out to to _patchfile

- Returns

0 on success

1 on failure

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `personality_enqueue_module`

- Synopsis

    personality_enqueue_module module profiles/flags/etc

- Description

Build the queue for tests

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `root_postlog_compare`

- Synopsis

    root_postlog_compare testtype branchlog patchlog

- Description

Root-level post-patch log handler. Files should be linecomments compatible!

- Returns

0 on success

1 on failure

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

## Private/Stable/Replaceable

### `prepopulate_footer`

- Synopsis

    prepopulate_footer

- Description

Put the opening environment information at the bottom of the footer table

- Returns

Nothing

Classification | Level
--- | ---
Audience | Private
Stability | Stable
Replaceable | Yes

### `report_jvm_version`

- Synopsis

    report_jvm_version directory

- Description

Report the JVM vendor and version of the given directory

- Returns

vendor and version string

Classification | Level
--- | ---
Audience | Private
Stability | Stable
Replaceable | Yes

## Private/Evolving/Replaceable

### `start_coprocessors`

- Synopsis

    start_coprocessors

- Description

Start any coprocessors

- Returns

Nothing

Classification | Level
--- | ---
Audience | Private
Stability | Evolving
Replaceable | Yes

### `stop_coprocessors`

- Synopsis

    stop_coprocessors

- Description

Stop any coprocessors

- Returns

Nothing

Classification | Level
--- | ---
Audience | Private
Stability | Evolving
Replaceable | Yes

### `verify_patchdir_still_exists`

- Synopsis

    verify_patchdir_still_exists

- Description

Verify that the patch directory is still in working order since bad actors on some systems wipe it out. If not, recreate it and then exit

- Returns

may exit on failure

Classification | Level
--- | ---
Audience | Private
Stability | Evolving
Replaceable | Yes